
LIBRARY IEEE;
use ieee.std_logic_1164.ALL;
  
--LIBRARY WORK;
--use WORK.ALL;

entity c_register is
  generic (width : integer := 4);
  port (input : in std_logic_vector((width-1) downto 0);
        WR: in std_logic;
        reset : in std_logic;
        clock : in std_logic;
        output : out std_logic_vector((width -1) downto 0));
end c_register;

architecture behavior of c_register is
begin
  P0 : process(clock, reset)
       begin
       
          if (reset = '1') then
              output <= (others => '0');
	  elsif clock = '1' and clock'event then
	  	if WR = '1' then
             		output <= input;
	   	end if;
          end if;

  end process P0;
end behavior;
